print("                                                           ")
print("                GenericHeroGuy presents...                 ")
print("       Brought to you by a boring Saturday night...        ")
print(" And many complaints about performance when tech is on...  ")
print("                                                           ")
print("                JUICEBOX: SQUEEZED EDITION                 ")
print("         Same taste you've always loved,                   ")
print("                 now distilled into a perfect mix!         ")
print("                                                           ")
print("             Brewed by Tyron - aj@worldsbe.st              ")
print("           Served with <3 by Sunflower's Garden            ")
print("                                                           ")
print("              Thank you to the Juicebox team!              ")
print("Additional sounds - Runa, Lazuli, Eebrozgi                 ")
print("Additional graphics - Chengi, Eebrozgi                     ")
print("Some original concepts - Chromatian, VelocitOni            ")
print("Teching prototypes - Wolfs, Barkley                        ")
print("Code contributions - Lat, Snu, Wolfs                       ")
print("Testing and support - ALL Neps illuminati!, ALL KCS wizards")
print("                                                           ")
print("            And of course, thank you to all the            ")
print("           awesome people of Sunflower's Garden!           ")
print("  There's so many of you, I dunno where to even begin...   ")
print("                                                           ")


rawset(_G, "CONFIG_Queue", CONFIG_Queue or {})

local function CONFIG_RegisterVar(var)
	table.insert(CONFIG_Queue, var)
	return CV_RegisterVar(var)
end


local TICRATE, FRACUNIT = TICRATE, FRACUNIT
local BT_ACCELERATE, BT_BRAKE, BT_DRIFT = BT_ACCELERATE, BT_BRAKE, BT_DRIFT
local PST_LIVE = PST_LIVE
local KITEM_SNEAKER = KITEM_SNEAKER
local KITEM_ROCKETSNEAKER = KITEM_ROCKETSNEAKER
local KITEM_SHRINK = KITEM_SHRINK
local KITEM_GROW = KITEM_GROW
local KITEM_INVINCIBILITY = KITEM_INVINCIBILITY
local KITEM_HYUDORO = KITEM_HYUDORO
local KITEM_JAWZ = KITEM_JAWZ
local KITEM_BALLHOG = KITEM_BALLHOG
local k_spinouttimer = k_spinouttimer
local k_driftcharge = k_driftcharge
local k_driftboost = k_driftboost
local k_itemtype = k_itemtype
local k_itemamount = k_itemamount
local k_itemblink = k_itemblink
local k_itemroulette = k_itemroulette
local k_growshrinktimer = k_growshrinktimer
local k_eggmanexplode = k_eggmanexplode
local k_rocketsneakertimer = k_rocketsneakertimer
local k_stolentimer = k_stolentimer
local k_stealingtimer = k_stealingtimer
local k_sadtimer = k_sadtimer
local k_squishedtimer = k_squishedtimer
local k_drift = k_drift
local k_hyudorotimer = k_hyudorotimer
local k_position = k_position

local MF2_DONTDRAW = MF2_DONTDRAW
local FF_TRANS20, FF_TRANS40, FF_TRANS80 = FF_TRANS20, FF_TRANS40, FF_TRANS80
local FF_FRAMEMASK, FF_TRANSMASK = FF_FRAMEMASK, FF_TRANSMASK

local A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z
    = A, B, C, D, E, F, G, H, I, J, K, L, M, N, O, P, Q, R, S, T, U, V, W, X, Y, Z

-- INIT START

-- Small things that didn't fit into their own module

rawset(_G, "JUICEBOX", CV_RegisterVar({
	name = "juicebox",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = { Off = 0, On = 1, Tech = 2}
}))

local JUICEBOX_tips = CONFIG_RegisterVar{
	name = "jb_tips",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,

	config_menu = "Other",
	displayname = "Tech tips",
	description = "Print a tip in chat after each round of Tech."
}

local jb_stackcut = {value = 60}
local jb_stackmax = {value = 90}
local jb_stackscale = {value = 7}

local function JUICEBOX_Stack(p, boost, isgateboost)
	local taxifromtr = (9 - p.kartspeed) + (p.kartweight - 1)
	local stackcut = max(jb_stackmax.value - jb_stackscale.value*taxifromtr, jb_stackcut.value)
	--print(taxifromtr, stackcut)
	--print("STACK: "..boost.." + "..p.kartstuff[k_driftboost])
	
	if JUICEBOX.value == 1 then
		if p.kartstuff[k_driftboost] > boost then -- existing boost is getting cut, so we need to cut gateboost visual if any
			p.gateboostflash = FixedInt(FixedMul($*FRACUNIT, stackcut*FRACUNIT/100))
		end
		if isgateboost and p.kartstuff[k_driftboost] < boost then -- won't be cut, add wholesale
			p.gateboostflash = $ + boost
		elseif isgateboost then -- will be cut
			p.gateboostflash = $ + FixedInt(FixedMul(boost*FRACUNIT, stackcut*FRACUNIT/100))
		end
	end
	
	p.kartstuff[k_driftboost] = max($, boost) + FixedInt(FixedMul(min($, boost)*FRACUNIT, stackcut*FRACUNIT/100))
	--print("= "..p.kartstuff[k_driftboost])
end

local function JUICEBOX_TechPenalty(p, consolation)
	p.gatedecay = $ or 100
	p.techpenalty = $ or -9999
	if abs(p.techpenalty - leveltime) >= 5*TICRATE
		if consolation
			p.gatedecay = 6*$/9
		else
			p.gatedecay = 6*$/11
		end
		p.gatedecay = max(10, $)
	end
	p.techpenalty = leveltime
end

local JUICEBOX_dp = 0
local JUICEBOX_renderer = 0
local JUICEBOX_dwatch = {}
local JUICEBOX_players = 0
local JUICEBOX_weightadjust = 0
local JUICEBOX_splitscreen = 0

-- G: P_IsLocalPlayer skips displayplayers[0] and uses consoleplayer instead
-- so this is needed to play sounds properly when speccing someone
local function JUICEBOX_StartLocalSound(sfx, p)
	if p.JBlocal then
		S_StartSound(nil, sfx) -- G: don't pass player here or else it doesn't play when speccing someone in a netgame
	end
end

-- If player has latency from "lag" addon, use it for lag compensation
local function JUICEBOX_GetLatency(p)
	return max(p.cmd.latency, p._finallatency or 0)
end

-- G: how could I possibly remove this
local function JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx, p) -- I don't want to talk about it, okay
	if p.JBlocal then
		S_StartSoundAtVolume(nil, sfx, 255/(JUICEBOX_splitscreen+1))
	end
end

local tips = {
--	[[The longer you hold an item, the shorter your gate boosts get. Watch the gate meter!]],
--	[[Dash Gates get stronger and larger over time. If you're behind, make them a priority.]],
--	[[Heavy characters drop bigger Dash Gates, and fast characters drop them more often.]],
	[[After taking a hit, press ACCEL when you see "GO" to rocket ahead!]],
--	[[While holding Hyudoro, check the minimap to see stealable items.]],
	[[Hyudoro gives you a small speed and acceleration boost.]],
--	[[In Juicebox, you respawn instantly, but dying on purpose to avoid eggboxes won't work.]],
--	[[Miniturbos and gate boosts can stack -- with themselves AND with each other!]],
	[[When you get a new item, it can't be stolen for 3 seconds.]],
	[[If your sneakers are stolen by Hyudoro, you'll launch forward as if you'd used them.]],
	[[Cancelling Grow early gives you a small miniturbo. Make the most of item boxes!]],
--	[[Light accel characters excel at snap cornering and recovery -- good for players who like risky attacks.]],
--	[[Heavy accel characters can chain huge miniturbos with ease -- good for players who like to hold their ground.]],
--	[[Lightweight speed characters get the most mileage from gates -- good for players who want to weave through danger.]],
--	[[Heavy speed characters reward confident cornering and active defense -- good for players who focus on precision.]],
--	[[To disable gate screenshake or end-of-race tips, see luafiles/juicebox.cfg.]],
	[[While in-air, you can hold BRAKE to fall faster. Becareful though, you may fall too fast]],
	[[Use your sneakers with full adventage! A guide has been posted in Sunflower's Garden Discord server!]],
}

local JUICEBOX_netdebug = CV_RegisterVar({
	name = "jb_netdebug",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_NOSHOWHELP,
	possiblevalue = CV_OnOff
})

local JUICEBOX_reducemotion = CONFIG_RegisterVar{
	name = "jb_reducemotion",
	defaultvalue = "Off",
	possiblevalue = CV_OnOff,

	config_menu = "Other",
	displayname = "Reduce motion",
	description = "(Juicebox) Don't shake the screen when going through a Dash Gate."
}

local JUICEBOX_growrefund = CV_RegisterVar({
	name = "jb_growrefund",
	defaultvalue = "Always",
	possiblevalue = {
		Off = 0,
		On = 1,
		Always = 2,
	},
})

rawset(_G, "JUICEBOX_Active", false)

addHook("MapLoad", function()
	rawset(_G, "JUICEBOX_Active", JUICEBOX.value)
end)

addHook("NetVars", function(net)
	rawset(_G, "JUICEBOX_Active", net(JUICEBOX_Active))
end)
-- INIT END

-- MAGNETBONK START
local function noplayercollide(mo,mo2)
	if JUICEBOX_Active and mo2 and mo2.valid and mo2.player
	and mo2.player.kartstuff[k_spinouttimer] > 0 and mo2.player.kartstuff[k_spinouttimer] <= 5 then
		return false
	end
end
addHook("MobjCollide", noplayercollide, MT_PLAYER)
addHook("MobjMoveCollide", noplayercollide, MT_PLAYER)
-- MAGNETBONK END

-- HASTE 2: AYYSTE
-- Stacks duration of miniturbos.
local function ayyste(p)
	if p.NAlastdriftboost ~= nil then

		--[[ CUSTOM EDIT: removed from SG
			-- Lawnmowering is already effective enough in a few edge cases, let's not let Omega get away with murder.
			-- This only activates if you spend too long offroad; no need to punish grazes on MKSC Sky Garden or something.
			if p.kartstuff[k_offroad] >= (FRACUNIT / 2) and p.kartstuff[k_driftboost] and p.NAlastadjust
				local mowdrop = max(p.kartstuff[k_driftboost] - p.NAlastadjust, 0)
				--print(p, "Deducting", p.NAlastadjust, "for offroad penalty! Was", p.kartstuff[k_driftboost], "F, is", mowdrop, "F")
				p.kartstuff[k_driftboost] = mowdrop
				p.NAlastadjust = 0
			end
		--]]

		-- This is a sort of roundabout way of detecting drifts, but we can't rely on adjustments to k_driftboost alone...
		-- If we're a 1 speed character, a blue MT should boost us from 20F to 26F by default.
		-- However, if we chain a red into a blue with 23F left on the timer, the game will ignore it!
		-- This is because the base value of a blue MT, 20F, is less than the value we currently have...
		-- ...so in the base game, applying that MT would actually slow us down, even though Haste would boost it up again!
		if p.NAlastdriftcharge > p.kartstuff[k_driftcharge] then
			-- Our goal is to detect an MT one frame after it's happened, then retroactively apply the bonus time.
			local target = K_GetKartDriftSparkValue(p) -- Taken from source.
			local LDC = p.NAlastdriftcharge
			local fakecharge = 20 -- Taken from source.
			--local fakename = "blue"
			-- This is a bunch of redundant safety conditions because I'm kinda paranoid.
			-- At least the most common ones are at the top.
			if p.kartstuff[k_driftboost] < 19 then
				--dprint(p, "No adjustment: no existing MT timer")
				return
			elseif p.speed <= 10*FRACUNIT then
				--dprint(p, "No adjustment: you're too slow")
				return
			elseif p.kartstuff[k_spinouttimer] then
				--dprint(p, "No adjustment: you're spun out")
				return
			elseif p.kartstuff[k_squishedtimer] then
				--dprint(p, "No adjustment: you're squished")
				return
			elseif LDC < target then
				--dprint(p, "No adjustment: didn't charge enough")
				return
			elseif p.NAlastbuttons then
				--dprint(p, "No adjustment: Drift not released")
				return
			elseif LDC >= target*4 then -- Rainbow and red MT values taken from source.
				fakecharge = 125
				--fakename = "rainbow"
			elseif LDC >= target*2 then
				fakecharge = 50
				--fakename = "red"
			end

			-- local accel = max(0, (9 - p.kartspeed - p.kartweight/2))
			local accel = max(0, 9 - p.kartspeed)

			-- Figure out how strong we're proportionally boosting MTs.
			local bonusfactor = FixedDiv((130 - 100)*FRACUNIT, 100*FRACUNIT)
			-- Figure out how much of that bonus a character is eligible for, based on their stats.
			-- 1 speed gets full bonus: 9 speed gets none! (In practice, 7+ speed gets 0F bonuses.)
			local diefactor = FRACUNIT + FixedMul(FixedDiv(bonusfactor, FRACUNIT*8), accel*FRACUNIT)
			-- Calculate the length of the target type of MT with bonus applied...
			-- ...minus 1 for the frame it's already been going.
			local holding = FixedInt(FixedMul(fakecharge*FRACUNIT, diefactor)) - 1
			-- Fixed point math is terrible.
			--dprint(p, "Correcting", fakename.." MT to", holding, "F, would be", p.kartstuff[k_driftboost], "F (scaled by", diefactor, ")")
			--p.NAlastadjust = max(holding - fakecharge, 0)
			--print("LAST: "..p.NAlastdriftboost.."  CURRENT: "..p.kartstuff[k_driftboost].."  NEW: "..holding)
			if p.NAlastdriftboost then
				JUICEBOX_Stack(p, holding)
			else
				p.kartstuff[k_driftboost] = holding
			end
		end
	end

	p.NAlastdriftboost = p.kartstuff[k_driftboost]
	p.NAlastdriftcharge = p.kartstuff[k_driftcharge]
	p.NAlastdrift = p.kartstuff[k_drift]
	p.NAlastbuttons = p.cmd.buttons & BT_DRIFT
	--p.NAlastadjust = $ or 0
end
-- HASTE END

-- MANTA START
-- previously cvars for testing purposes, intentionally removed
local jb_manta_turbo = {value = 40}
local jb_manta_spacing = {value = 5000}
local jb_manta_spacescale = {value = 250}
local jb_manta_size = {value = 62500}
local jb_manta_sizescale = {value = 8192}
local jb_manta_grace = {value = 0}
local jb_manta_sizeup = {value = 10}
local jb_manta_sizestrength = {value = 1500}
local jb_manta_itemcut = {value = 100}
local jb_manta_grow = {value = 18}
local jb_manta_haste = {value = true}
local jb_manta_racetime = {value = 90}
local jb_manta_collide = {value = 80*FRACUNIT}
local jb_manta_maxramp = {value = 80}
local jb_manta_nspower = {value = 10}
local jb_manta_nsstrong = {value = 20}
local jb_manta_nsweak = {value = 36}
local jb_manta_fastramp = {value = 17}
local jb_manta_minpwr = {value = 10}
local jb_manta_vstart = {value = 150}
local jb_manta_vrate = {value = 60}
local jb_manta_vmax = {value = 100}
local jb_manta_vfstart = {value = 6}
local jb_manta_vfroll = {value = 5}
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local STARTTIME = 6*TICRATE + (3*TICRATE/4)
local splitval, splittime, splitflag
// "speed sphincters" - /vm/, 2021
freeslot("sfx_gatefx", "sfx_mnsrc", "SPR_TRNQ", "MT_MANTARING")

mobjinfo[MT_MANTARING] = {
	spawnstate = S_UNKNOWN,
	flags = MF_SPECIAL|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	radius = jb_manta_collide.value*2,
	height = 256*FRACUNIT -- sprite height
}

addHook("MobjSpawn", function(mo)
	mo.boostval = jb_manta_turbo.value
	-- doing what TSR does except not really
	local delay = max(15, jb_manta_racetime.value/mapheaderinfo[gamemap].numlaps)
	if mapheaderinfo[gamemap].levelflags & LF_SECTIONRACE
		delay = 60
	end
	if JUICEBOX_netdebug.value then
		delay = 120
	end
	mo.fuse = delay*TICRATE
	mo.colorized = true
	mo.timealive = 0

	mo.sprite = SPR_TRNQ
	mo.frame = S | FF_FULLBRIGHT|FF_PAPERSPRITE|FF_TRANS40
	mo.realz = mo.z
end, MT_MANTARING)

local function buildTimeString(x)
	return string.format("%02d", G_TicsToMinutes(x, true)).."' "..string.format("%02d", G_TicsToSeconds(x))..'" '..string.format("%02d", G_TicsToCentiseconds(x))
end

-- G: seems like this was originally made for an mobjcollide hook but was put in the thinker?
-- now we don't have to iterate players, check if they're specced, etc etc
-- also improves accuracy by exploiting P_TryMove's repeated checks
--
-- i absolutely CANNOT afford to use MobjCollide because of fucking explosions
-- trust me, just 64 calls to this thing in one tic will tank performance
-- so gotta make sure the sprite and hitbox are centered, don't want people clipping through the bottom of the ring
addHook("TouchSpecial", function(mo, pmo)
	local player = pmo.player
	local dx, dy, dz = abs(pmo.x - mo.x), abs(pmo.y - mo.y), abs(pmo.z - mo.realz)
	local distance = FixedHypot(FixedHypot(dx, dy),dz) - (pmo.radius) - (64*mo.scale) -- was mo.radius, had to enlarge so we don't miss any collisions

	--if print("Testing collision with "..player.name..", distance = "..distance..", max = "..jb_manta_collide.value) or
	if abs(distance) > jb_manta_collide.value
	or mo.owner == player
	or (player.touchedgates and player.touchedgates[mo.gateid])
	or player.kartstuff[k_position] == 1
	or player.laps > mo.ownerlaps then
		return true
	end
	
	player.touchedgates = $ or {}

	--print("ZOOM!")

	local addboost
	if player.kartstuff[k_growshrinktimer] > 0 then
		addboost = jb_manta_grow.value
	elseif player.kartstuff[k_itemamount] > 0 then
		addboost = (jb_manta_itemcut.value * mo.boostval / 100)
	else
		addboost = mo.boostval
	end

	-- if JUICEBOX_players > jb_manta_vfstart.value then
	--[[if false then -- Guava PT1 player rolloff changes. these sucked!
		local keepboost = addboost
		addboost = (100 - ((JUICEBOX_players - jb_manta_vfstart.value) * jb_manta_vfroll.value)) * addboost / 100
		table.insert(JUICEBOX_dwatch, "\130VF "..keepboost.." "..addboost)
		print("VF "..keepboost.." "..addboost)
	end--]]

	--print(addboost)

	if not player.gatedecay then player.gatedecay = 100 end -- hack for lat's mystery errors
	local holding = player.gatedecay * addboost / 100
	--print(holding)
	if jb_manta_haste.value then
		--local p = player
		--local accel = max(0, (9 - player.kartspeed - player.kartweight/2))
		local accel = max(0, 9 - player.kartspeed)
		local target = (26*4 + player.kartspeed*2)*8
		local bonusfactor = FixedDiv((130 - 100)*FRACUNIT, 100*FRACUNIT)
		local diefactor = FRACUNIT + FixedMul(FixedDiv(bonusfactor, FRACUNIT*8), accel*FRACUNIT)
		holding = FixedInt(FixedMul(holding*FRACUNIT, diefactor))
	end

	if mo.timealive < jb_manta_fastramp.value then
		--print("going in: "..holding)
		holding = max(jb_manta_minpwr.value, FixedInt(FixedMul(FixedDiv(mo.timealive*FRACUNIT, jb_manta_fastramp.value*FRACUNIT), $*FRACUNIT)))
		--print("coming out: "..holding)
	end

	JUICEBOX_Stack(player, holding, true)
	player.techedrecently = TICRATE/4
	JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_gatefx, player)
	if player.JBlocal and not (JUICEBOX_splitscreen or JUICEBOX_reducemotion.value) then
		P_StartQuake(FRACUNIT*12, 6)
	end
	player.touchedgates[mo.gateid] = leveltime

	mo.touched = true

	if JUICEBOX_dp == mo.owner and not mo.touched and player.kartstuff[k_position] == 2 then
		splitval = "-"..buildTimeString(leveltime - mo.droppedtime)
		splitflag = V_SKYMAP
		splittime = leveltime
	elseif JUICEBOX_dp == player then
		splitval = "+"..buildTimeString(leveltime - mo.droppedtime)
		splitflag = V_REDMAP
		splittime = leveltime
	end

	return true
end, MT_MANTARING)

addHook("MobjThinker", function(mo)
	if not mo.valid then return end -- sigh thanks srb2 hook system

	mo.timealive = $ + 1
	mo.z = mo.realz - mo.height/2 -- the dirty trick mentioned above

	if JUICEBOX_dp and JUICEBOX_dp.valid and JUICEBOX_dp.touchedgates then
		if (mo.owner == JUICEBOX_dp and (not JUICEBOX_splitscreen)) then
			mo.flags2 = $|MF2_DONTDRAW
		elseif (mo.ownerlaps < JUICEBOX_dp.laps) and (not JUICEBOX_splitscreen)
			mo.flags2 = $|MF2_DONTDRAW
		else
			if (JUICEBOX_dp.touchedgates[mo.gateid]) and ((JUICEBOX_dp.touchedgates[mo.gateid]) < (leveltime - 5*TICRATE)) and (not JUICEBOX_splitscreen) then
				mo.flags2 = $|MF2_DONTDRAW
			else
				mo.flags2 = $&(~MF2_DONTDRAW)
			end
		end

		local alivegate = FF_TRANS40
		local deadgate = FF_TRANS80

		if ((JUICEBOX_dp.touchedgates[mo.gateid] or JUICEBOX_dp.kartstuff[k_position] == 1) and (not JUICEBOX_splitscreen)) then
			mo.frame = $&(~FF_TRANSMASK)|deadgate
		else
			mo.frame = $&(~FF_TRANSMASK)|alivegate
		end
	end

	-- if consoleplayer and consoleplayer.touchedgates[mo.gateid] then mo.flags2 = $|MF2_SHADOW else mo.flags2 = $&(~MF2_SHADOW) end

	-- G: "WHY ARE YOU ANIMATING IN LUA YOU DICKHEAD"
	-- this isn't just about squeezing performance, this is also about squeezing freeslots :troll:
	if mo.fuse % 3 == 1 then -- 1 because i want the first frame to also last 3 tics
		-- S_MANTA1
		if (mo.frame & FF_FRAMEMASK) >= S then
			mo.frame = $ + 1
			if (mo.frame & FF_FRAMEMASK) > U then
				mo.frame = A | (mo.frame & ~FF_FRAMEMASK)
				local dsd = 32*mapobjectscale
				local tx, ty, tz = mo.x - FixedMul(dsd, cos(mo.angle + ANGLE_90)), mo.y - FixedMul(dsd, sin(mo.angle + ANGLE_90)), mo.realz
				mo.dropshadow = P_SpawnMobj(tx, ty, tz, MT_THOK)
				mo.dropshadow.flags = $ | MF_NOTHINK -- G: become stupid
				mo.dropshadow.sprite = SPR_TRNQ
				mo.dropshadow.frame = FF_FULLBRIGHT|FF_PAPERSPRITE|FF_TRANS20
				mo.dropshadow.color = mo.color
				mo.dropshadow.angle = mo.angle
			end
		-- S_MANTA2
		else
			mo.frame = (($ & FF_FRAMEMASK + 1) % 12) | ($ & ~FF_FRAMEMASK)
		end
	end

	if mo.dropshadow then
		mo.dropshadow.scale = mo.scale -- G: have to scale manually because no thinker
		mo.dropshadow.flags2 = mo.flags2
		mo.dropshadow.frame = M + ((mo.frame & FF_FRAMEMASK) % 6) | ($ & ~FF_FRAMEMASK) | (JUICEBOX_renderer ~= "software" and (mo.frame & FF_TRANSMASK) or 0)
	end

	-- G: smooth it out, my dude
	if not (mo.fuse % jb_manta_sizeup.value) then
		mo.destscale = mo.scale + jb_manta_sizestrength.value
		mo.boostval = min(jb_manta_maxramp.value, $ + 1)
	end
	--]]
end, MT_MANTARING)

-- G: yay, free timer!
-- use this to just kill the dropshadow
addHook("MobjFuse", function(mo)
	P_RemoveMobj(mo.dropshadow)
end, MT_MANTARING)

local gateid
local totaldist
--local gamespeed -- G: hardcode already has this?
local vscale
addHook("NetVars", function(net)
	gateid = net(gateid)
	totaldist = net(totaldist)
	--gamespeed = net(gamespeed)
	vscale = net(vscale)
end)
-- MANTA END

-- QUICKRECOVERY START
local JUICEBOX_snipecancelqr = CV_RegisterVar({
	name = "jb_snipecancelqr",
	defaultvalue = "On",
	possiblevalue = CV_OnOff,
	flags = CV_NETVAR,
})

local function JUICEBOX_CanQuickRecover(p)
	if p.JBhascontrol == nil then return end -- weird hack for weird lat errors, wonder what init order is causing this
	return ((p.JBhascontrol < TICRATE*3) and p.JBQRok and not p.JBQRsniped)
end

addHook("PlayerSpin", function(p, inflictor)
	if (not JUICEBOX_Active) or (JUICEBOX_snipecancelqr.value == 0) or not (inflictor and inflictor.valid) then return end

	if not (inflictor.type == MT_BANANA_SHIELD) and (inflictor.type == MT_BANANA) and inflictor.health > 1 then
		p.JBQRsniped = true
	end
end)

local function quickrecovery(p)
	local mo = p.mo
	local ks = p.kartstuff

	p.JBhascontrol = $ or 0
	-- p.JBqrok = $ or false

	-- CUSTOM EDIT: banana snipe
	if not p.kartstuff[k_spinouttimer] then
		p.JBQRsniped = false
	end

	if (ks[k_spinouttimer] or ks[k_squishedtimer]) and not p.respawnflash then
		p.JBQRok = not p.JBQRsniped -- CUSTOM EDIT: banana snipe
		p.JBhascontrol = 0
	else
		if P_IsObjectOnGround(mo) then -- if we somehow recover from spinout in midair (water?), extend leniency
			p.JBhascontrol = $ + 1 -- i think in airpunt situations this might give you a free MT while already moving forward
		else -- but airtechs already do this so what the fuck ever, can't control for everything and the gains > the losses
			return -- (also make sure you can't blow your QR in the air, idiot)
		end
		if JUICEBOX_CanQuickRecover(p) and (p.cmd.buttons & BT_ACCELERATE) and not (p.cmd.buttons & BT_BRAKE) then
			-- we should never branch here with a loss-of-control flag set, so no need to actually recover the player
			-- CUSTOM EDIT: banana snipe
			if not p.JBQRsniped then
				ks[k_driftboost] = 21
				S_StartSound(mo, sfx_s23c, p)
			end

			p.JBQRok = false
			JUICEBOX_TechPenalty(p, true)
		end
	end

	if p.JBhascontrol and JUICEBOX_CanQuickRecover(p) and (not p.techcuering) then
		local notshitty = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_TECHFLASH)
		notshitty.target = p.mo
		--notshitty.momx, notshitty.momy, notshitty.momz = player.mo.momx, player.mo.momy, player.mo.momz
		notshitty.colorized = true
		notshitty.state = S_TECHFLASH4
		notshitty.color = p.skincolor
		--JUICEBOX_StartLocalSound(sfx_s227, player)
		p.techcuering = true
	end
end
-- QUICKRECOVERY END

-- TECH START
freeslot("sfx_tekyes")
freeslot("sfx_tekprf")

-- [TYRON] was TICRATE/2 (17)
local techwindow = TICRATE/3
-- [TYRON] was 23
local lockout = 2*TICRATE/3

local function realtechwindow(p)
	return (techwindow + (9 - min(p.kartweight, JUICEBOX_weightadjust)))
end

local jb_techringpre = {value = 7}

-- haste shit
local bonusfactor = 3*FRACUNIT/10

local function TechBoost(player, consolation)

	local diefactor = FRACUNIT + FixedMul(FixedDiv(bonusfactor, FRACUNIT*8), (9-min(player.kartspeed, JUICEBOX_weightadjust))*FRACUNIT)
	local holding = FixedInt(FixedMul(20*FRACUNIT, diefactor))

	player.kartstuff[k_driftboost] = 26

	if (player.kartstuff[k_spinouttimer]) then
		if abs(player.kartstuff[k_spinouttimer] - realtechwindow(player)) <= 1 then -- perfect!
			JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s25f, player)
			if CV_FindVar("kartvoices").value then
				local techsound = (leveltime%2) and sfxinfo[sfx_kbost1] or sfxinfo[sfx_kbost2]
				JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(skins[player.mo.skin].soundsid[techsound.skinsound], player)
			end
			player.techsparkle = TICRATE
		end
		player.kartstuff[k_spinouttimer] = 0
	end

	if consolation then
		JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s23c, player)
		player.kartstuff[k_driftboost] = $ - 5
	else
		JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_tekyes, player)
		player.techedrecently = TICRATE/4 -- [TYRON] controls length of sparkle trail post-tech
	end

	player.JBQRok = false
	player.JBhascontrol = 999
	player.techcue = false
	player.techcuering = false

	JUICEBOX_TechPenalty(player, consolation)
end

freeslot("MT_TECHFLASH")
freeslot("S_TECHFLASH1")
freeslot("S_TECHFLASH2")
freeslot("S_TECHFLASH3")
freeslot("S_TECHFLASH4")
freeslot("S_TECHFLASHXD")
freeslot("SPR_TKFL")
freeslot("SPR_TKLT")
mobjinfo[MT_TECHFLASH] = {
	spawnstate = S_TECHFLASHXD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY,
	dispoffset = 10, -- BE CAREFUL WITH THIS FUCKING PARAMETER, too high and you'll run into broken camera culling behavior in OGL at low cam_dist
	height = 48*FRACUNIT -- (and make sure you set this too, if you don't specify it Lua sets it to 0 and you get weird software culling)
}
states[S_TECHFLASHXD] = {
	sprite = SPR_NULL,
	frame = A|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_TECHFLASH1
}
states[S_TECHFLASH1] = { -- intro
	sprite = SPR_TKFL,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 15,
	var2 = 1,
	tics = 15,
	nextstate = S_TECHFLASH2
}
states[S_TECHFLASH2] = { -- "TECH OK" ring loop
	sprite = SPR_TKFL,
	frame = Q|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 3,
	var2 = 1,
	nextstate = S_TECHFLASH2
}
states[S_TECHFLASH3] = { -- expand, fade out to QR visual
	sprite = SPR_TKFL,
	frame = U|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 4,
	var2 = 1,
	tics = 5,
	nextstate = S_TECHFLASH4
}
states[S_TECHFLASH4] = { -- "QR OK" ring loop
	sprite = SPR_TKLT,
	frame = A|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 7,
	var2 = 1,
	tics = 8,
	nextstate = S_TECHFLASH4
}
addHook("MobjSpawn", function(mo)
	mo.animtimer = 0
end, MT_TECHFLASH)
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.target and mo.target.valid) then return end
	mo.animtimer = $ + 1

	if mo.target.player.tech then
		P_RemoveMobj(mo)
	else
		if mo.target.player.kartstuff[k_spinouttimer] <= JUICEBOX_GetLatency(mo.target.player) and (mo.state != S_TECHFLASH3 and mo.state != S_TECHFLASH4) then
			mo.state = S_TECHFLASH3
		end
	end
end, MT_TECHFLASH)

freeslot("MT_TECHBUTTON")
freeslot("S_TECHBUTTON")
freeslot("S_TECHBUTTONB")
freeslot("S_TECHBUTTONXD")
freeslot("SPR_TKBT")
mobjinfo[MT_TECHBUTTON] = {
	spawnstate = S_TECHBUTTONXD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY,
	dispoffset = 11,
	height = 48*FRACUNIT
}
states[S_TECHBUTTONXD] = {
	sprite = SPR_NULL,
	frame = A|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_TECHBUTTON
}
states[S_TECHBUTTON] = {
	sprite = SPR_TKBT,
	frame = A|FF_FULLBRIGHT
}
states[S_TECHBUTTONB] = {
	sprite = SPR_TKBT,
	frame = C|FF_FULLBRIGHT|FF_ANIMATE,
	var1 = 1,
	var2 = 1,
	tics = 6,
	nextstate = S_NULL
}

local function encoreflip(mo) end

if FF_HORIZONTALFLIP then
	encoreflip = function(mo)
		if encoremode then mo.frame = mo.frame | FF_HORIZONTALFLIP end
	end
end

addHook("MobjSpawn", function(mo)
	mo.animtimer = 0
end, MT_TECHBUTTON)
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.target and mo.target.valid) then return end
	mo.animtimer = $ + 1
	if (mo.target.player != JUICEBOX_dp and (not JUICEBOX_splitscreen)) then mo.flags2 = $|MF2_DONTDRAW else mo.flags2 = $&(~MF2_DONTDRAW) end
	if mo.animtimer == 2 then
		mo.frame = B|FF_FULLBRIGHT
	elseif mo.animtimer == 8 then
		mo.frame = C|FF_FULLBRIGHT
	end
	
	encoreflip(mo)
	
	if mo.target.player.tech then
		P_RemoveMobj(mo)
	else
		if mo.target.player.kartstuff[k_spinouttimer] <= (6 + JUICEBOX_GetLatency(mo.target.player)) and (mo.state != S_TECHBUTTONB) then
			--mo.markedfordeath = $ or 0
			--mo.markedfordeath = $ + 1
			--if mo.target.player == JUICEBOX_dp then
				--mo.flags2 = (mo.markedfordeath % 2) and ($|MF2_DONTDRAW) or ($&~(MF2_DONTDRAW))
			--end
			--if mo.markedfordeath == 8 then
				--P_RemoveMobj(mo)
			--end
			mo.state = S_TECHBUTTONB
		end
	end
end, MT_TECHBUTTON)

freeslot("MT_TECHLOCK")
freeslot("S_TECHLOCK")
freeslot("S_TECHLOCKXD")
mobjinfo[MT_TECHLOCK] = {
	spawnstate = S_TECHLOCKXD,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY,
	dispoffset = 12,
	height = 48*FRACUNIT
}
states[S_TECHLOCKXD] = {
	sprite = SPR_NULL,
	frame = A|FF_FULLBRIGHT,
	tics = 1,
	nextstate = S_TECHLOCK
}
states[S_TECHLOCK] = {
	sprite = SPR_TKBT,
	frame = E|FF_FULLBRIGHT
}
addHook("MobjSpawn", function(mo)

end, MT_TECHLOCK)
addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.target and mo.target.valid) then return end
	if (mo.target.player != JUICEBOX_dp and (not JUICEBOX_splitscreen)) then mo.flags2 = $|MF2_DONTDRAW else mo.flags2 = $&(~MF2_DONTDRAW) end
	if mo.target.player then
		if mo.target.player.lockout then
			mo.frame = E|FF_FULLBRIGHT
			if mo.target.player.lockout == lockout then
				mo.scale = 12*(mo.target.scale)/10
				mo.destscale = mo.target.scale
			end
		else
			P_RemoveMobj(mo)
		end
	else
		P_RemoveMobj(mo)
	end
end, MT_TECHLOCK)

local killme = {MT_TECHBUTTON, MT_TECHFLASH, MT_TECHLOCK}
for i = 1, #killme
	addHook("MobjThinker", function(mo)
		if not (mo and mo.valid) then return end
		if leveltime == 1 then -- I AM TIRED OF THIS HAPPENING
			P_RemoveMobj(mo)
			return
		end
		if mo.target and mo.target.valid and mo.target.player
		and mo.target.player.playerstate == PST_LIVE then
			P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
			mo.angle = mo.target.angle
			--mo.momx, mo.momy, mo.momz = mo.target.momx, mo.target.momy, mo.target.momz
			if (mo.target.player.lockout or (not P_IsObjectOnGround(mo.target))) and mo.type != MT_TECHLOCK then
				--mo.flags2 = $|MF2_SHADOW
			else
				--mo.flags2 = $&(~MF2_SHADOW)
			end
		else
			P_RemoveMobj(mo)
			return
		end
		-- achtung big hack, need to remove tech visuals if your spinout is somehow extended
		local player = mo.target.player
		local techwindowadj = realtechwindow(player)
		if mo.type == MT_TECHBUTTON then
			if player.techcue and (player.kartstuff[k_spinouttimer] > (techwindowadj + JUICEBOX_GetLatency(player) + 1)) then
				--print("removing button out of range")
				P_RemoveMobj(mo)
				player.techcue = false
				player.lockout = 0
				return
			end
		elseif mo.type == MT_TECHFLASH then
			if player.techcuering and (player.kartstuff[k_spinouttimer] > (techwindowadj + JUICEBOX_GetLatency(player) + jb_techringpre.value + 1)) then
				--print("removing ring out of range")
				P_RemoveMobj(mo)
				player.techcuering = false
				player.lockout = 0
				return
			elseif (mo.state == S_TECHFLASH4 or mo.state == S_TECHFLASH3) and (not JUICEBOX_CanQuickRecover(player))
				--print("removing ring no QR")
				player.techcuering = false
				P_RemoveMobj(mo)
				return
			end
		end
	end, killme[i])
end

-- base code by Wolfs, concept by Wolfs+Barkley
local function tech(player)
	-- CUSTOM EDIT: banana snipe
	if player.JBQRsniped then
		return -- go fuck yourself
	end

	if leveltime == 1 then -- experimental patch for techvisual fucking off?
		player.techcue = false
		player.techcuering = false
		player.JBQRok = false
		player.techpenalty = -9999
	end

	-- Declare initial variables and handle resets
	if (player.tech == nil)
	or ((player.kartstuff[k_spinouttimer] == 0) and (player.kartstuff[k_driftboost] == 0)) then
		player.tech = 0
		player.lockout = 0
		player.accelcounter = $ or 0
		player.brakecounter = $ or 0
	end

	player.techpenalty = $ or -9999

	player.techedrecently = $ or 0 -- [TYRON] little accent for techboosts
	player.techedrecently = max($-1, 0)
	if player.techedrecently then
		K_SpawnSparkleTrail(player.mo)
	end

	player.techsparkle = $ or 0 -- fuck it
	player.techsparkle = max($-1, 0)
	if player.techsparkle and (not player.techedrecently) and (leveltime%2) then
		K_SpawnSparkleTrail(player.mo)
	end

	if (player.lockout > 0) then
		player.lockout = $-1 -- Count down the lockout every frame
	end

	-- Count held accelerate inputs, used for lockout
	if (player.cmd.buttons & BT_ACCELERATE) then
		player.accelcounter = $+1
	else
		player.accelcounter = 0
	end

	-- [TYRON] fuck it
	if (player.cmd.buttons & BT_BRAKE) then
		player.brakecounter = $+1
		-- player.accelcounter = 0 -- Allows for instant techs when BRAKE is released.
		-- Not implementing this just yet: seems to require too much finesse when releasing after RBT.
	else
		player.brakecounter = 0
	end

	if (player.kartstuff[k_spinouttimer]) and (not player.mo.ggz_frozen) then
		-- [TYRON] More lenient techs for lighter fucks
		local techwindowadj = realtechwindow(player)
		table.insert(JUICEBOX_dwatch, "RTW: "..techwindowadj)

		if (true) then
			-- [TYRON] latency-adjusted tech window visual cue
			if not player.techcue and (player.kartstuff[k_spinouttimer] <= (techwindowadj + JUICEBOX_GetLatency(player) + 1)) then
				local shitty = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TECHBUTTON)
				shitty.target = player.mo
				--shitty.momx, shitty.momy, shitty.momz = player.mo.momx, player.mo.momy, player.mo.momz
				player.techcue = true
				JUICEBOX_StartLocalSound(sfx_ddash, player)
			end

			if not player.techcuering and (player.kartstuff[k_spinouttimer] <= (techwindowadj + JUICEBOX_GetLatency(player) + jb_techringpre.value + 1)) then
				local notshitty = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TECHFLASH)
				notshitty.target = player.mo
				--notshitty.momx, notshitty.momy, notshitty.momz = player.mo.momx, player.mo.momy, player.mo.momz
				notshitty.colorized = true
				notshitty.color = player.skincolor
				JUICEBOX_StartLocalSound(sfx_s227, player)
				player.techcuering = true
			end
		end

		-- SUCCESS TIMING WINDOW: Any accelerate inputs within this window will result in a tech.
		if (player.tech == 0)
		and (player.kartstuff[k_spinouttimer] <= (techwindowadj)) -- [TYRON] Moved lag compensation to the visual
		-- this isn't like startboosts, where everyone's action is determined at the same time;
		-- we want laggy players to press earlier so their input arrives on time. a later spinout cancel is competitively worse!
		and (player.lockout == 0) then
			if (player.accelcounter == 1) and (player.brakecounter == 0) then
				if 	P_IsObjectOnGround(player.mo) then
					TechBoost(player)
				else
					player.airtech = true
					player.JBhascontrol = 999
				end
				player.tech = 1
			end
		end

		-- LOCKOUT: If the player presses accelerate before the timing window begins, lock their input from counting towards techs.
		if (player.accelcounter == 1) and (player.brakecounter < player.accelcounter)
		and ((player.kartstuff[k_spinouttimer]) > (techwindowadj)) then
			player.lockout = lockout
			JUICEBOX_StartLocalSound(sfx_s268, player)
			local shame = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TECHLOCK)
			shame.target = player.mo
		end
	else
		player.techcue = false -- [TYRON] unset this out here dummy
		if not JUICEBOX_CanQuickRecover(player)
			player.techcuering = false
		end
	end

	if P_IsObjectOnGround(player.mo) and player.airtech then
		TechBoost(player)
		player.airtech = false
	end
end
-- TECH END

addHook("MapLoad", function()
	-- mantaring.lua
	totaldist = 30000
	gateid = 1
	--gamespeed = CV_FindVar("kartspeed").value
	vscale = jb_manta_vstart.value
	for p in players.iterate do
		p.touchedgates = {}
		p.gatedecay = 100
		p.gatebarhappy = 100
	end
	splittime = -9999

	-- init.lua
	if JUICEBOX_Active then
		for p in players.iterate do
			p.juicetips = 0
		end
	end
end)

addHook("MapLoad", function()
	for p in players.iterate do
		p.JBlastgst = nil
	end
end)

addHook("ThinkFrame", function()
	if JUICEBOX_growrefund.value == 0 or (JUICEBOX_growrefund.value == 1 and JUICEBOX.value == 0) then return end
	if leveltime == 0 then return end
	
	for p in players.iterate do
		if not p.mo then continue end
		local ks = p.kartstuff
	
		-- JUICEBOX "Grow Refund"
		-- Awards a short miniturbo when canceling Grow.
		-- Duration depends on remaining Grow timer.
		if p.JBlastgst and p.JBlastgst > 1 and not ks[k_growshrinktimer] then
			JUICEBOX_Stack(p, min(40, 2*p.JBlastgst/3))
			S_StartSound(p.mo, sfx_s23c)
		end
		p.JBlastgst = ks[k_growshrinktimer]
	end
end)

addHook("ThinkFrame", function()
	if not JUICEBOX_Active or leveltime == 0 then return end

	JUICEBOX_dwatch = {}
	JUICEBOX_players = 0
	JUICEBOX_splitscreen = splitscreen
	for p in players.iterate do
		if p.spectator then continue end

		JUICEBOX_players = $ + 1
		p.JBlocal = false
		for dp in displayplayers.iterate do
			if p == dp then
				p.JBlocal = true
				break
			end
		end
	end

	JUICEBOX_weightadjust = 9 - (JUICEBOX_players - 6)/2

	-- shoutouts to aqua and jugador, you fucks LMAO
	-- nice catch but y'all nearly gave me a heart attack
	-- if JUICEBOX_netdebug.value then jb_manta_grace.value = 1 end
	local didfirst = false
	for p in players.iterate do
		if leveltime == 0 then p.JBflashhold = 0 end -- stealsafety.lua
		if p.spectator then continue end
		local mo = p.mo
		local ks = p.kartstuff

		-- init.lua
		if p.exiting or (p.lives == 0) then
			p.juicetips = $ or 0
			p.juicetips = $ + 1
			p.juicetipreceived = $ or {}
			if p.juicetips == 2*TICRATE then
				local pendingtip = (leveltime%#tips)
				local received = 0
				for key, val in pairs(p.juicetipreceived)
					received = $ + 1
				end
				if received < #tips then
					repeat
						pendingtip = ($+1)%#tips
					until not p.juicetipreceived[pendingtip]
					p.juicetipreceived[pendingtip] = true
					if JUICEBOX_tips.value then
						chatprintf(p, "\136Tech Tip: "..tips[pendingtip+1], true)
					end
				end
			end
		end

		p.gateboostflash = p.playerstate ~= PST_LIVE and $ or 0
		p.gatedecay = $ or 100
		p.gateboostflash = max(0, $ - 1)
		if p.gateboostflash and not (leveltime%3) and not ks[k_spinouttimer] then
			local fug = P_SpawnGhostMobj(p.mo)
			fug.colorized = true
			if p.JBlocal then
				fug.flags2 = $ & ~MF2_DONTDRAW
			else
				fug.flags2 = $|MF2_DONTDRAW
			end
		end

		-- ayyste.lua
		ayyste(p)

		-- JUICEBOX "Hyudoro Misfire"
		-- Makes boost items forcibly activate when stolen.
		-- Safer shortcuts, but more chaos!
		if p.playerstate == PST_LIVE and max(ks[k_spinouttimer], ks[k_wipeoutslow]) == 0 then
			p.JBlastitem = $ or 0
			if ks[k_stolentimer] > TICRATE/2-2 and (p.JBlastitem == KITEM_SNEAKER or p.JBlastitem == KITEM_ROCKETSNEAKER) then
				K_DoSneaker(p, 1)
			end
			p.JBlastitem = ks[k_itemtype]
		end

		-- JUICEBOX "Steal Safety"
		-- Extends the unstealable window after you roll an item.
		if not ks[k_itemtype] then
			p.JBflashhold = 0
		end
		if ks[k_itemblink] == 3 then
			p.JBflashhold = TICRATE*2
		end
		if p.JBflashhold then
			ks[k_itemblink] = 2
			p.JBflashhold = $ - 1
			if p.JBflashhold == 1 then
				ks[k_itemblink] = 0
			end
		end

		-- quickrecover.lua
		quickrecovery(p)

		-- tech.lua
		tech(p)

		-- G: end of tech-only stuff
		if JUICEBOX_Active == 2 then continue end

		-- fasthyu.lua
		if ks[k_hyudorotimer] then
			ks[k_speedboost] = max($, FRACUNIT/4)
			ks[k_accelboost] = max($, FRACUNIT/4)
		end

		-- G: not in battle beyond this point
		if G_BattleGametype() then continue end

		-- itemnerfer.lua
		--[[ CUSTOM EDIT: removed
		if ks[k_itemblink] == TICRATE and ks[k_itemtype] and ks[k_itemamount] then
			if ks[k_itemtype] == KITEM_SNEAKER then ks[k_itemamount] = min(2, $) end
		end
			if ks[k_rocketsneakertimer] then
				if (abs(p.lastrockettimer) - ks[k_rocketsneakertimer]) > 3 then
					ks[k_rocketsneakertimer] = max(0, $ - 3*TICRATE/4)
				end
				if leveltime % 2 then
					--ks[k_rocketsneakertimer] = max(0, $ - 1)
				end
			end
			p.lastrockettimer = ks[k_rocketsneakertimer]
		--]]

		-- mantarings.lua
		if (ks[k_itemtype] and ks[k_itemamount]) or ks[k_rocketsneakertimer] then
			local it = ks[k_itemtype]
			local ia = ks[k_itemamount]
			local dcheck = jb_manta_nsweak.value
			if it == KITEM_ROCKETSNEAKER or it == KITEM_SHRINK or it == KITEM_GROW or it == KITEM_INVINCIBILITY or (it == KITEM_SNEAKER and ia >= 2) then
				dcheck = jb_manta_nspower.value
			elseif it == KITEM_HYUDORO or (it == KITEM_JAWZ and ia >= 2) or it == KITEM_BALLHOG or it == KITEM_SNEAKER then
				dcheck = jb_manta_nsstrong.value
			elseif ks[k_rocketsneakertimer] then
				dcheck = 9999
			end
			p.decayflashrate = dcheck
			if (leveltime % dcheck) == 0 then
				p.gatedecay = max(10, $ - 1)
				if p.gatedecay == 62 then
					JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s3k7c, p)
					JUICEBOX_StartLocalSoundWithScaledVolumeInThisGorillaSpaghettiSplitscreenSystem(sfx_s3k7c, p)
				end
			end
			p.gatedecay = min(99, $) -- inelegant hack to make hud easier
		else
			if not (leveltime%5)
				p.gatedecay = min($+1, 100)
			end
			if not (leveltime%(5+2*p.kartspeed))
				p.gatedecay = min($+1, 100)
			end
		end
		if p.gatedecay == 100 then
			if p.gatebarhappy == 0 then
			JUICEBOX_StartLocalSound(sfx_mnsrc, p)
			end
			p.gatebarhappy = $+1
		else
			p.gatebarhappy = 0
		end
		if ((leveltime <= (STARTTIME+TICRATE*jb_manta_grace.value)) and (not JUICEBOX_netdebug.value)) or ks[k_position] != 1 then continue end
		-- housekeeping's over, let's anger some frontrunners!
		if not didfirst then
			if not (leveltime % jb_manta_vrate.value) then
				vscale = max($ - 1, jb_manta_vmax.value)
			end
			local spacing = jb_manta_spacing.value - p.kartspeed * jb_manta_spacescale.value
			if gamespeed == 1 then
				spacing = $ / 20 * 17 -- 85%
			elseif gamespeed == 0 then
				spacing = $ / 10 * 7 -- 70%
			end
			table.insert(JUICEBOX_dwatch, "SPC: "..spacing)
			table.insert(JUICEBOX_dwatch, "VS: "..vscale)
			local finaldist = FixedMul(FixedMul(spacing*FRACUNIT, mapheaderinfo[gamemap].mobj_scale), FixedDiv(vscale*FRACUNIT, 100*FRACUNIT))
			table.insert(JUICEBOX_dwatch, "FD: "..finaldist)
			table.insert(JUICEBOX_dwatch, "VFS: "..jb_manta_vfstart.value)
			table.insert(JUICEBOX_dwatch, "P: "..JUICEBOX_players)
			totaldist = $ + abs(FixedHypot(mo.momx, mo.momy)) -- xd
			if totaldist > finaldist and P_IsObjectOnGround(mo) then
				totaldist = 0
				local ring = P_SpawnMobj(mo.x, mo.y, mo.z, MT_MANTARING)
				ring.owner = p
				ring.droppedtime = leveltime
				ring.touched = false
				ring.color = p.skincolor
				ring.ownerspeed = p.kartspeed
				ring.ownerweight = min(p.kartweight, JUICEBOX_weightadjust)
				ring.ownerlaps = p.laps
				ring.gateid = gateid
				if p == consoleplayer and (not JUICEBOX_splitscreen) then ring.flags2 = $|MF2_DONTDRAW else ring.flags2 = $&(~MF2_DONTDRAW) end
				ring.scale = FixedMul(mo.scale, jb_manta_size.value + jb_manta_sizescale.value*ring.ownerweight)
				ring.angle = R_PointToAngle2(0, 0, mo.momx, mo.momy) + ANGLE_90
				P_SetOrigin(ring, ring.x, ring.y, ring.z - ring.height/2) -- G: no ugly first frames on my watch!
				ring.destscale = INT32_MAX
				ring.scalespeed = jb_manta_sizestrength.value / jb_manta_sizeup.value
				gateid = $ + 1
			end
			table.insert(JUICEBOX_dwatch, "SP: "..spacing)
			table.insert(JUICEBOX_dwatch, "TD: "..totaldist)
			didfirst = true
		end
	end
end)


local V_SNAPTOTOP, V_SNAPTOBOTTOM, V_SNAPTOLEFT, V_SNAPTORIGHT = V_SNAPTOTOP, V_SNAPTOBOTTOM, V_SNAPTOLEFT, V_SNAPTORIGHT
local V_SPLITSCREEN, V_HORZSCREEN, V_HUDTRANS, V_HUDTRANSHALF = V_SPLITSCREEN, V_HORZSCREEN, V_HUDTRANS, V_HUDTRANSHALF
local V_ALLOWLOWERCASE, V_FLIP = V_ALLOWLOWERCASE, V_FLIP
local TC_RAINBOW, TC_ALLWHITE, TC_BLINK = TC_RAINBOW, TC_ALLWHITE, TC_BLINK
local SKINCOLOR_WHITE, SKINCOLOR_GREEN, SKINCOLOR_RED, SKINCOLOR_BLACK = SKINCOLOR_WHITE, SKINCOLOR_GREEN, SKINCOLOR_RED, SKINCOLOR_BLACK

-- DEBUG STUFF
local jb_debug = CV_RegisterVar({
	name = "jb_debug",
	defaultvalue = "Off",
	flags = CV_NOSHOWHELP,
	possiblevalue = CV_OnOff
})

local function b2s(x)
	return x and "\131Y" or "\133N"
end

-- Lua itemhud recreation.
-- Adapted by Snu from TSR, by Snu. xd
local function returnSplitflags(f, displaynum)
	-- exhibit 1: 2p
	if JUICEBOX_splitscreen == 1 then
		if not (displaynum) -- p1
			return f & ~(V_SNAPTOBOTTOM)
		else	-- p2
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP)
		end
	elseif JUICEBOX_splitscreen > 2 then
		-- jesus fuck this sucks dicks
		if not (displaynum)	-- p1
			return f & ~(V_SNAPTOBOTTOM|V_SNAPTORIGHT)
		elseif (displaynum == 1)	-- p2
			return (f|V_HORZSCREEN) & ~(V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		elseif (displaynum == 2)	-- p3
			return (f|V_SPLITSCREEN) & ~(V_SNAPTOTOP|V_SNAPTORIGHT)
		elseif (displaynum == 3)	-- p4
			return (f|V_SPLITSCREEN|V_HORZSCREEN) & ~(V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end

	return f
end

hud.add(function(v, p, c)
	-- init.lua
	JUICEBOX_dp = p
	JUICEBOX_renderer = v.renderer()

	-- debug.lua
	if not JUICEBOX_Active then return end
	if jb_debug.value then
		local ll = 1
		local rl = 1
		local ks = p.kartstuff
		local function dll(s)
			v.drawString(5, ll*10-5, s, V_ALLOWLOWERCASE|V_SNAPTOLEFT)
			ll = $ + 1
		end
		local function dlr(s)
			v.drawString(315, rl*10-5, s, V_ALLOWLOWERCASE|V_SNAPTORIGHT, "right")
			rl = $ + 1
		end
		dll("MT: "..ks[k_driftboost])
		dll("SPIN: "..ks[k_spinouttimer])
		dll("BLINK: "..ks[k_itemblink])
		dll("")
		dll("FH: "..p.JBflashhold)
		dll("TR: "..p.techedrecently)
		dll("TC: "..b2s(p.techcue))
		dll("TCR: "..b2s(p.techcuering))
		dll("GBF: "..p.gateboostflash)
		dll("L: "..b2s(p.lockout))
		dll("CTL: "..p.JBhascontrol)
		dll("QR: "..b2s(p.JBQRok))
		dll("CQR: "..b2s(JUICEBOX_CanQuickRecover(p)))

		dlr(JUICEBOX_renderer)
		for key, val in ipairs(JUICEBOX_dwatch) do
			dlr(val)
		end
	end

	-- itemhud.lua
	if G_BattleGametype() or JUICEBOX_Active == 2 or not (p.mo and p.gatedecay) then return end
	local right = c.pnum == 2 or c.pnum == 4
	local x, y = 5, JUICEBOX_splitscreen and 3 or 5
	local flags = returnSplitflags(V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS, c.pnum - 1)
	if JUICEBOX_splitscreen > 1 then
		x, y = right and 121 or -9, -8
		flags = returnSplitflags(V_SNAPTOLEFT|V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS, c.pnum - 1)
	end
	x = x + (CV_FindVar("hud_item_xoffset") and CV_FindVar("hud_item_xoffset").value or 0)
	y = y + (CV_FindVar("hud_item_yoffset") and CV_FindVar("hud_item_yoffset").value or 0)

	-- unseal when fuckery is required
	--local tx = 320 - 148
	--local ty = 9
	--local timeflags = returnSplitflags(V_SNAPTORIGHT|V_SNAPTOTOP|V_HUDTRANS, c.pnum - 1)
	--v.draw(tx, ty, v.cachePatch("J_STTIMW"), timeflags, v.getColormap(TC_BLINK, SKINCOLOR_PINK))

	local gatebarsplit = JUICEBOX_splitscreen > 1 and "S" or "R"
	if JUICEBOX_splitscreen == 1 then gatebarsplit = "M" end
	local gatebar = v.cachePatch("GBA"..gatebarsplit..((leveltime/3)%4)..(100-p.gatedecay))
	local showgatebar = p.gatedecay < 100 or p.gatebarhappy < (1*TICRATE/3+6) or p.kartstuff[k_itemtype]

	if showgatebar then
		local tcol = v.getColormap(p.mo.skin, p.mo.color)
		local tflag = flags&(~V_HUDTRANS)|((p.kartstuff[k_position] == 1) and V_HUDTRANSHALF or V_HUDTRANS)
		if p.gatedecay == 100 and (leveltime % 2) then
			tcol = v.getColormap(TC_ALLWHITE, SKINCOLOR_WHITE)
		elseif p.techedrecently and (leveltime % 2) then
			tcol = v.getColormap(TC_BLINK, p.skincolor)
		elseif (abs(p.techpenalty - leveltime) <= TICRATE/2) and (leveltime % 2)
			tcol = v.getColormap(TC_RAINBOW, SKINCOLOR_RED)
		elseif p.kartstuff[k_position] == 1 then
			tcol = v.getColormap(TC_RAINBOW, SKINCOLOR_BLACK)
		--[[
		elseif p.decayflashrate and p.kartstuff[k_itemtype] and (not ((leveltime/3)%(p.decayflashrate)))
			tcol = v.getColormap(TC_RAINBOW, SKINCOLOR_RED)
			tflag = $&(~V_HUDTRANS)|V_HUDTRANSHALF
		elseif p.gatedecay <= 98 and (not p.kartstuff[k_itemtype]) and (not ((leveltime/3)%(TICRATE/3)))
			 tcol = v.getColormap(TC_RAINBOW, SKINCOLOR_GREEN)
			tflag = $&(~V_HUDTRANS)|V_HUDTRANSHALF
		--]]
		end

		if JUICEBOX_splitscreen > 1 then
			if right then
				v.draw(x+13, y+34, gatebar, V_FLIP|tflag, tcol)
			else
				v.draw(x+35, y+34, gatebar, tflag, tcol)
			end
		else
			v.draw(x+46, y+46, gatebar, tflag, tcol)
		end
	end

	if showgatebar and
	not (p.kartstuff[k_itemtype] or p.kartstuff[k_itemroulette] or p.kartstuff[k_growshrinktimer] > 0 or p.kartstuff[k_eggmanexplode]
	or p.kartstuff[k_rocketsneakertimer] or p.kartstuff[k_stealingtimer] or p.kartstuff[k_stolentimer] or p.kartstuff[k_sadtimer]) then
		v.draw(x, y, v.cachePatch(JUICEBOX_splitscreen < 2 and "K_ITBG" or "K_ISBG"), flags&(~V_HUDTRANS)|V_HUDTRANSHALF)
	end

	-- Splits are, like, seriuously not ready and I don't know if they'll ever be
	--[[
	if true then return end
	if G_BattleGametype() then return end
	if not JUICEBOX_Active then return end
	if (not splittime) or (not splitval) then return end
	if JUICEBOX_splitscreen then return end

	local fadetime = 3*TICRATE
	if (leveltime-splittime)>fadetime then return end
	local off = 3-min(leveltime-splittime, 3)
	local out = min((splittime+fadetime)-leveltime, 3)
	v.drawString(160+1*off-1*(3-out), 70, splitval, splitflag|V_SNAPTOTOP|V_ALLOWLOWERCASE|((3+(off+(3-out)))<<V_ALPHASHIFT), "center")
	--]]
end)